using System;
using System.Collections.Generic;

namespace MySystem
{
    /// <summary>
    /// 商户修改银行卡
    /// </summary>
    public class ChangeMerchantCard
    {
        public string mchtNo { get; set; }//收款商户号
        public string accountName { get; set; }//开户名（账户名称 账户类型 0-对公 时填写对公账户名，1-对私 时填写银行卡户名）
        public string accountNo { get; set; }//卡号(账户类型 0-对公 时填写对公账号，1-对私 时填写银行卡号)
        public string accoutType { get; set; }//账户类型 0-对公，1-对私
        public string zbankNo { get; set; }//开户支行号
        public string alterType { get; set; }//结算类型：0-对公结算银行卡；1-法人对私结算银行卡；2-非法人结算
        public string acctZbankCode { get; set; }//开户支行地区码
        public string idCard { get; set; }//非法人身份证号(结算类型为2时必填)
        public string agentCardDate { get; set; }//非法人身份证有效期(结算类型为2时必填，格式：20210101-20220101，如长期：20210101-长期)
        public string openBankAccName { get; set; }//开户许可证-开户名(修改对公凭证时填写)
        public string openBankName { get; set; }//开户许可证-银行名称(修改对公凭证时填写)
        public string openCollectBankCode { get; set; }//开户许可证-银行代码(修改对公凭证时填写)
        public string openBankRegionCode { get; set; }//开户许可证-银行地区码(修改对公凭证时填写)
        public string openBankRegionName { get; set; }//开户许可证-开户地名称(修改对公凭证时填写)
        public string openUnionNo { get; set; }//开户许可证-开户支行(修改对公凭证时填写)
        public string openUnionName { get; set; }//开户许可证-支行名称(修改对公凭证时填写)
        public string openBankAccout { get; set; }//开户许可证-银行卡号(修改对公凭证时填写)
        public List<PhotoItem> photoList { get; set; }//图片列表

    }

    /// <summary>
    /// 图片类
    /// </summary>
    public class PhotoItem
    {
        public string mediaCode { get; set; }//图片名
        public string mediaPath { get; set; }//图片token
    }

}
